package com.lemoulinstudio.jnag.apt.generator;

import com.lemoulinstudio.jnag.apt.type.Type;
import com.lemoulinstudio.jnag.apt.type.TypeKind;
import com.lemoulinstudio.jnag.rds.AbstractConfiguration;
import com.lemoulinstudio.jnag.rds.Decoder;
import com.lemoulinstudio.jnag.rds.JnagSessionImpl;
import com.lemoulinstudio.jnag.rds.Proxy;
import com.lemoulinstudio.jnag.rds.RootDecoder;
import com.sun.sgs.app.ManagedReference;
import java.io.Serializable;

/**
 *
 * @author Vincent Cantin
 */
public class RdsCodeGenerator extends JavaCodeGenerator {

  public RdsCodeGenerator() {
    super(JnagSessionImpl.class,
            AbstractConfiguration.class,
            Proxy.class,
            RootDecoder.class,
            Decoder.class,
            ", " + Serializable.class.getName(),
            "\n" +
            "  /** The version of the serialized form of this class. */\n" +
            "  private static final long serialVersionUID = 1L;\n");
  }

  @Override
  protected String toString(Type type, boolean isReceiverSide, boolean isGenericArgument, boolean noManagedReference) {
    if (!noManagedReference && type.getTypeKind() == TypeKind.Model) {
      return (isGenericArgument && !isReceiverSide ? "? extends " : "") +
              ManagedReference.class.getName() + "<" + super.toString(type, isReceiverSide, true, noManagedReference) + ">";
    }
    else
      return super.toString(type, isReceiverSide, isGenericArgument, noManagedReference);
  }

}
